import { system, world } from "@minecraft/server";
system.runInterval(() => {
    for (const player of world.getPlayers()) {
        if (player.isOnGround) player.jumpCount = 0;
        if (player.isJumping && !player.isOnGround && !player.lastJumping) {
            ++player.jumpCount;
        }
        const playerPos = player.location;
            const playerDirection = player.getViewDirection();
            const baseBlockPos = {x: Math.floor(playerPos.x + playerDirection.x),y: Math.floor(playerPos.y - 0.5),z: Math.floor(playerPos.z + playerDirection.z)
            };
            const baseBlock = player.dimension.getBlock(baseBlockPos);
            const topBlockPos = {x: baseBlockPos.x,y: baseBlockPos.y + 1,z: baseBlockPos.z};
            const topBlock = player.dimension.getBlock(topBlockPos);
        if (player.jumpCount === 2) {
            if (baseBlock && topBlock.typeId.includes('slab') || topBlock.typeId.includes('fence')) {
                player.applyKnockback(0, 0, 0, 0.5);
            }
            player.jumpCount = 0;
        }
        else if(player.jumpCount === 1) {
            if(topBlock.typeId.includes('fence') || topBlock.typeId.includes('wall')) {
                player.applyKnockback(0, 0, 0, 0.5);
            }
        }
        player.lastJumping = player.isJumping;
    }
}, 1);